﻿Type=Activity
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private tmrStartClient As Timer 
End Sub

Sub Globals
	Private moSU As StringUtils 
	Private fbConnecting As Boolean = False
	

	Private btnConnect As Button
	Private lvwChat As ListView
	Private panChat As Panel
	Private txtSend As EditText
	Private txtServer As EditText
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("layClient")
	
	' chat box	
	Dim poLabel As Label 
	Dim poBack As ColorDrawable 
	poBack.Initialize(Colors.White, 0)
	poLabel = lvwChat.SingleLineLayout.Label 
	poLabel.TextSize = 14
	poLabel.Background = poBack
	poLabel.TextColor = Colors.Black
	poLabel.Width = lvwChat.Width 
	lvwChat.SingleLineLayout.ItemHeight = moSU.MeasureMultilineTextHeight(poLabel, "GUID-GUID-yy")
	poLabel.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	txtSend.ForceDoneButton = True 
	txtServer.ForceDoneButton = True
	
	
End Sub

Sub Activity_Resume
	lvwChat.Clear 
	txtServer.Text = "10.0.0.154"
	StartService(srvSockets)
	
	panChat.Enabled = False
	txtServer.Enabled = True 
	txtServer.RequestFocus 
	btnConnect.Text = "Connect"

	tmrStartClient.Initialize("tmrStartClient", 250)
	tmrStartClient.Enabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnConnect_Click
	If fbConnecting Then
		Return
	End If 

	If CallSub(srvSockets, "Connected_ToServer") = False Then
		If srvSockets.ServiceStarted Then
			If CallSub(srvSockets, "Client_Ready") = True Then
				If txtServer.text.Trim <> "" Then
					fbConnecting = True
					CallSub2(srvSockets, "Client_Connect", txtServer.Text.Trim)
				Else
					ToastMessageShow("Enter a valid IP and try again.", False)
				End If 
			Else
				ToastMessageShow("Client mode not ready, please wait a second and try again.", False)
			End If 
		Else
			ToastMessageShow("Service still starting, please wait a second and try again.", False)
		End If 
	Else
		fbConnecting = True
		CallSub(srvSockets, "Client_Disconnect")
	End If 
End Sub

Private Sub tmrStartClient_Tick
	If srvSockets.ServiceStarted Then
		tmrStartClient.Enabled = False 
		CallSub3(srvSockets, "Start_ClientMode", Me, "Client")
	End If 
End Sub 


Sub txtServer_EnterPressed
	btnConnect_Click
End Sub 

Sub txtSend_EnterPressed
	CallSub2(srvSockets, "Send_ToServer", txtSend.Text)
	lvwChat.AddSingleLine("Sent->" & txtSend.Text)
	lvwChat.SetSelection(lvwChat.Size - 1)
	txtSend.Text = ""
End Sub






Private Sub Client_ConnectedToServer
	fbConnecting = False
	btnConnect.text = "Disconnect"
	panChat.Enabled = True
	txtServer.Enabled = False 
End Sub 

Private Sub Client_DisconnectedFromServer
	fbConnecting = False 
	panChat.Enabled = False
	lvwChat.Clear 
	txtServer.Enabled = True 
	txtServer.RequestFocus 
	btnConnect.Text = "Connect"
End Sub 

Private Sub Client_ServerConnectError(ErrorMessage As String)
	fbConnecting = False 
	ToastMessageShow("Unable to connect to server:" & CRLF & ErrorMessage, True)
	Client_DisconnectedFromServer
End Sub 

Private Sub Client_DataFromServer(Data As String)
	lvwChat.AddSingleLine("Recv->" & Data)
	lvwChat.SetSelection(lvwChat.Size - 1)
End Sub 

Private Sub Client_ClientAStreamError(ErrorMessage As String)
	ToastMessageShow("Async stream error:" & CRLF & ErrorMessage, True)
End Sub 





