﻿Type=Activity
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private tmrStartServer As Timer 
End Sub

Sub Globals
	
	Private moSU As StringUtils 
	
	
	
	Private lblConn As Label
	Private lblIP As Label
	Private lvwChat As ListView
	Private lvwConnections As ListView
	Private panChat As Panel
	Private txtSend As EditText
	
	Type Connection(GUID As String, IPAdd As String)
	
	Private moConns As List
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Dim pfHeight As Float 
	
	Activity.LoadLayout("layServer") 
	moConns.Initialize 

	' line one label
	Dim poLabel As Label 
	Dim poBack As ColorDrawable 
	poBack.Initialize(Colors.Blue, 0)
	poLabel = lvwConnections.TwoLinesLayout.Label 
	poLabel.TextSize = 14
	poLabel.Background = poBack
	poLabel.TextColor = Colors.White 
	poLabel.Width = lvwConnections.Width 
	poLabel.Height = moSU.MeasureMultilineTextHeight(poLabel, "GUID-GUIDy")
	pfHeight = poLabel.Height 
	poLabel.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	
	' 2nd Line	
	Dim poLabel As Label 
	Dim poBack2 As GradientDrawable  
	Dim piCols(2) As Int = Array As Int (Colors.Blue, Colors.Black)
	poBack2.Initialize("TOP_BOTTOM", piCols)
	poBack2.CornerRadius = 0 
	poLabel = lvwConnections.TwoLinesLayout.SecondLabel 
	poLabel.TextSize = 12
	poLabel.Background = poBack2
	poLabel.Top = pfHeight
	poLabel.TextColor = Colors.Yellow
	poLabel.Width = lvwConnections.Width 
	poLabel.Height = moSU.MeasureMultilineTextHeight(poLabel, "IP: 888.8988.888")
	pfHeight = pfHeight + poLabel.Height 
	poLabel.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	lvwConnections.TwoLinesLayout.ItemHeight = pfHeight
	
	' chat box	
	Dim poLabel As Label 
	Dim poBack As ColorDrawable 
	poBack.Initialize(Colors.White, 0)
	poLabel = lvwChat.SingleLineLayout.Label 
	poLabel.TextSize = 14
	poLabel.Background = poBack
	poLabel.TextColor = Colors.Black
	poLabel.Width = lvwChat.Width 
	lvwChat.SingleLineLayout.ItemHeight = moSU.MeasureMultilineTextHeight(poLabel, "GUID-GUID-yy")
	poLabel.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	txtSend.ForceDoneButton = True 
End Sub

Sub Activity_Resume
	lvwConnections.Clear 
	lvwChat.Clear 
	StartService(srvSockets)
	tmrStartServer.Initialize("tmrStartServer", 250)
	tmrStartServer.Enabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	moConns.Clear 
	lvwChat.Clear
	lvwConnections.Clear 
	CallSub(srvSockets, "Stop_Server")
	StopService(srvSockets)
End Sub

Private Sub tmrStartServer_Tick
	Log("Checking to see if service is ready")
	If srvSockets.ServiceStarted Then
		tmrStartServer.Enabled = False
		Log("Calling start_server Mode")
		CallSub3(srvSockets, "Start_Server", Me, "Server")
	End If
End Sub

Private Sub txtSend_EnterPressed
	CallSub3(srvSockets, "Send_ToClient", "", txtSend.Text)
	lvwChat.AddSingleLine("Server->" & txtSend.Text)
	lvwChat.SetSelection(lvwChat.Size - 1)
	txtSend.Text = ""
End Sub






Private Sub Server_ServerStarted(ServerIP As String)
	lblIP.Text = "Server Running at " & ServerIP
End Sub 

Private Sub Server_Stopped
	lblIP.Text = "Server Stopped"
End Sub 

Private Sub Server_ClientConnected(GUID As String)
	Dim poNew As Connection
	poNew.Initialize 
	poNew.GUID = GUID
	poNew.IPAdd = CallSub2(srvSockets, "Get_ClientIP", GUID)
	moConns.Add(poNew)
	
	lvwConnections.AddTwoLines2(GUID, "   IP: " & poNew.IPAdd, GUID)
End Sub 

Private Sub Server_ClientConnectError(ErrorMEssage As String)
	ToastMessageShow("Client connect error:" & CRLF & ErrorMEssage, True)
End Sub 

Private Sub Server_AStreamError(GUID As String, ErrorMessage As String)
	ToastMessageShow("Atream Error for " & GUID & ":" & CRLF & ErrorMessage, True)
End Sub 

Private Sub Server_DataFromClient(GUID As String, Data As String)
	lvwChat.AddSingleLine("[" & GUID.SubString(GUID.Length - 3) & "] " & Data)
	lvwChat.SetSelection(lvwChat.Size - 1)
	' echo to other clients
	CallSub3(srvSockets, "Send_ToAllClients", GUID, Data)
End Sub 

Private Sub Server_ClientDisconnected(GUID As String)
	lvwChat.AddSingleLine("[" & GUID.SubString(GUID.Length - 3) & "] ** DISCONNECTED **")
	Dim piIndex As Int
	For piIndex = lvwConnections.Size - 1 To 0 Step -1
		If GUID = lvwConnections.GetItem(piIndex) Then
			lvwConnections.RemoveAt(piIndex)
		End If
	Next 
End Sub 
